/*
 *
 * SMS Plus! for the Dreamcast (Sega Master System emulator for the Dreamcast)
 * Original code Copyright (C) 1998, 1999, 2000 Charles Mac Donald
 * Dreamcast port Copyright (C) 2001 ss_teven
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 */

#include "shared.h"
#include "dc.h"
#include "dbp_image.h"

//included images
#include "splash.h"
#include "pressstart.h"
#include "mehnu.h"
#include "redblob.h"

#include "dcload-syscall.h"
//#include "dcload-syscalls.h"
#include "dcload-printf.h"



int gui_menu_load();

int dc_main() {

    snd.enabled = 0; /* this prolly still wont work by enabling it */

    init_machine();
    splash_screen();


    gui_menu();
    gui_menu_load();

    load_rom();
    system_init(0);
    load_sram();


    frame_count = 0;

    /* Main emulation loop */
    for(;;) {

        /* we got the exit flag, lets break */
        if(exit_flag) break;

        /* Bump frame count */
        frame_count += 1;

        /* Set skip flag based on frameskip settings */
        if(frame_count % frame_skip == 0)
            skip_flag = 0;
        else
            skip_flag = 1;

        /* Get current input */
        update_input();

        /* Run the SMS emulation for a frame */
        sms_frame(skip_flag);

        /* Update the display if desired */
        if(skip_flag == 0) {
           update_video();
        }

        /* Displays the frame count */
        if(show_dcfr == 1) display_fcount();
    }

    system_shutdown();
    trash_machine();
    return (0);
}


int gui_drawmenu(int choice) {
//   clearscr(640,480);
   int x,y;
      for(x = 256; x < 285; x++)
         for(y = 229; y < 362; y++)
            vram_s[640*y + x] = RGB565(0,0,0);
   dbp_load(p_redblob,256,229);
/*   if (choice==1) { bfont_draw_str(vram_s+140*s_width+130, s_width, "   o    Load game");
   } else { bfont_draw_str(vram_s+140*s_width+130, s_width, "        Load game"); }
   if (choice==2) { bfont_draw_str(vram_s+180*s_width+130, s_width, "   o    Options");
   } else { bfont_draw_str(vram_s+180*s_width+130, s_width, "        Options"); }
   if (choice==3) { bfont_draw_str(vram_s+220*s_width+130, s_width, "   o    Credits");
   } else { bfont_draw_str(vram_s+220*s_width+130, s_width, "        Credits"); }
   if (choice==4) { bfont_draw_str(vram_s+260*s_width+130, s_width, "   o    Exit");
   } else { bfont_draw_str(vram_s+260*s_width+130, s_width, "        Exit"); }
   */
   return(0);
}

int gui_menu() {
   uint8 mmcont;
   cont_cond_t mcond;
   int choice,a=1;

   mmcont = maple_controller_addr();
//   clearscr(640,480);
   dbp_load(p_splash,0,0);
   dbp_load(p_mehnu,292,229);
   gui_drawmenu(1);
   while(1) {
       if(cont_get_cond(mmcont, &mcond)) {
          return;
       }
//!(mcond.buttons  & pbutton)
       while(!a) {
          a=csleep3(60*1000,CONT_DPAD_DOWN,CONT_DPAD_UP,CONT_A);
       }
       if(a==1) {
          choice=choice+1;
       }
       if(a==2) {
          choice=choice-1;
       }
       if(a==3) {
          if (choice==1) {
//            clearscr(640,480);
             break;
          }
          if (choice==2) {
//             screenprintf(500, "Options not yet available",0);
             sleep(4*1000);
          }
          if (choice==3)
             credits();
          if (choice==4)
            exittomenu();
       }
       if (choice==5) { choice=1; }
       if (choice==0) { choice=4; }
       gui_drawmenu(choice);
       a=0;
       sleep(200);
   }
   return(0);
}

int gui_menu_load() {
   return(0);
}

int splash_screen() {
    int w, x, y;

    serial_printf("splash screen ...");
    dbp_load(p_splash,0,0);
    dbp_load(p_pressstart,(s_width/2)-(126/2),s_height/2);

    while(1) {
       w=csleep(1000,CONT_START);
          if (w==1) break;
       for(x = 100; x < 600; x++)
          for(y = 145; y < 300; y++)
             vram_s[640*y + x] = RGB565(255,255,255);
       w=0;
       w=csleep(1000,CONT_START);
          if (w==1) break;
       dbp_load(p_splash,0,0);
       dbp_load(p_pressstart,(s_width/2)-(126/2),s_height/2);
    }

    dbp_load(p_splash,0,0);
    serial_printf("... [ DONE ]\r\n");
    return(0);
}

int credits() {
   int y, x, w=1; char *title;
   clearscr(640,480);
   //title=stradd("SMS Plus! for the Dreamcast v1.0");
   while(1) {
      screenprintf(10+x , "SMS Plus! for the Dreamcast v1.0",w);
      screenprintf(150+x,"       Original Code by Charles Mac Donald",w);
      screenprintf(200+x,"       Ported to the Dreamcast by ss_teven",w);
      screenprintf(440+x,"  Thanks go to (in no specific order):",0);
      screenprintf(490+x,"      All the beta testers,",0);
      screenprintf(520+x,"         Sayten, Surfer PR, Heliophobe",0);
      screenprintf(550+x,"      All the guys in #dcdev and #dcemu",0);
      screenprintf(580+x,"      Dan Potter for Libdream",0);
      screenprintf(610+x,"      All my friends for showing me the real world",0);
      screenprintf(640+x,"      and everyone else who i missed!",0);
      screenprintf(750+x," dont forget to visit devcast.dcemulation.com",0);
      screenprintf(1100+x,"                  SMS Plus                  ",0);

      y=csleep(1000,CONT_A);
      if (y==1)
         break;
      clearscr(640,480);
      //vid_clear(0,0,0);
      x=x-1;
      w=0;
   }
   return(0);
}

/* csleep(int sleep, uint16 pbutton);  okay, now I hated that i
 * couldnt flash a message with it sleeping for 500ms, in that 500ms
 * sleep someone may have pushed a button or something, so what this
 * baby does is sleeps for 1ms and after each 1ms it searches for the
 * controller, and then sleeps for 1ms again, until the designated
 * sleep number is done then it breaks out and returns 0, or if the
 * button is pressed then it breaks out of the loop and returns 1
 */
int csleep(int slp, uint16 pbutton) {
   int s=1,a=0;
   uint8 mmcont;
   cont_cond_t mcond;

   mmcont = maple_controller_addr();
   if (!mmcont) {
      screenprintf(20,"Please plug in a controller!",1);
      while(!mmcont){
         mmcont = maple_controller_addr();
      }
   }
   while(1) {
          s++;
          if(cont_get_cond(mmcont, &mcond)) {
             return;
          }
          if(!(mcond.buttons  & pbutton)) {
             serial_printf("button was pressed\r\n");
             a=1;
             break;
          }
          sleep(1);
          if(s==slp) {
             a=0;
             break;
          }
   }
   return(a);
   return(0);
}

/* This clseep handles 3 buttons being pressed */
int csleep3(int slp, uint16 pbutton1, uint16 pbutton2, uint16 pbutton3) {
    int s,a;
    uint8 mmcont;
    cont_cond_t mcond;
    s = 1;
    mmcont = maple_controller_addr();
    if (!mmcont) {
       screenprintf(20,"Please plug in a controller!",1);
       while(!mmcont){
          mmcont = maple_controller_addr();
       }
    }
    while(1) {
          s++;
          if(cont_get_cond(mmcont, &mcond)) {
             return;
          }
          if(!(mcond.buttons  & pbutton1)) {
             serial_printf("button1 was pressed\r\n");
             a=1;
             break;
          }
          if(!(mcond.buttons  & pbutton2)) {
             serial_printf("button2 was pressed\r\n");
             a=2;
             break;
          }
          if(!(mcond.buttons  & pbutton3)) {
             serial_printf("button3 was pressed\r\n");
             a=3;
             break;
          }
          sleep(1);
          if(s==slp) {
             a=0;
             break;
          }
   }
   return(a);
   return(0);
}

void init_machine(void)
{

    /* Clear framebuffer */
    //fb_rect(0, 0, 0x3FF, 0x1FF, 0x1F, 0x1F, 0x1F);

#ifdef DCDEBUG
    serial_init(57600);
    serial_printf("SMS Plus! for the Dreamcast\r\n  a port by ss_teven\r\n");
#else
    serial_disable();
#endif


#ifdef NTSC
    dc_setup_quiet(DM_640x480, PM_RGB565);
#else
	/* Init video */
        Command_pal();
	/* Init sound */
	snd_init();
	/* Init CD-ROM */
	cdrom_init();
	iso_init();
	/* cd_init(); */
	/* Init input devices (Maple Bus) */
        maple_init(0);
	/* Init timers */
	timer_init();
#endif



#ifdef DCDEBUG
    serial_printf("Graphics mode set: 640x480 (RGB565)\r\n");
#endif


    /* Initialize display bitmap */
    serial_printf("Setting up bitmap ...");
    memset(&bitmap, 0, sizeof(t_bitmap));
    bitmap.width  = 256;
    bitmap.height = 192;
    bitmap.depth  = 8;
    bitmap.pitch  = (bitmap.width * (bitmap.depth >> 3));
    bitmap.data   = (unsigned char *)&bitmap_data[0];
    serial_printf(" DONE.\r\n");

    mcont = maple_controller_addr();
    if (!mcont) {
       screenprintf(20,"Please insert a controller.",1);
       serial_printf("Please insert a controller.\r\n");
       while(!mcont){
         mcont = maple_controller_addr();
       }
       return;
        }
    serial_printf("Controller detected.\r\n");
    init_splash();
    init_pressstart();
    init_redblob();
    init_mehnu();

    clearscr(640,480); /* get rid of the text outputted to screen (if any) */
}

#ifndef NTSC
void Command_pal()
{
unsigned long * reg_vid_enc = (unsigned long *)0xa05f80D0;
unsigned long * reg_vid_size = (unsigned long *)0xa05f80D8;

uint32 vsize_lace = (624 << 16);
uint32 vsize = (312 << 16);
uint32 hsize = 863;
uint32 video_size=0;

if( current_display_mode == DISPLAY_HIRES )
{
video_size = (vsize_lace | hsize);
}
else
{
video_size = (vsize | hsize);
}

*(reg_vid_enc) &= 0xffffff3f; //clear any content from videomode
*(reg_vid_enc) |= 0x00000040; //set videomode to PAL

*(reg_vid_size) = video_size; //set videosize

dc_type = DC_TYPE_PAL;

return;
}
#endif


void trash_machine(void)
{
    clearscr(640,480);
    screenprintf(20,"Thankyou for using SMS Plus! for the Dreamcast",1);
    serial_printf("Thankyou for using SMS Plus! for the Dreamcast\r\n");
    sleep(2000);
    exittomenu();
    for(;;); /* loop forever till power down, just incase exittomenu failed */
}

void update_video(void)
{
    int x, y, c, r, g, b;

    /* Width and height of viewport */
    //int w = (cart.type ? 160 : 256);
    //int h = (cart.type ? 144 : 192);
    int w = 160;
    int h = 144;

    /* Offset in framebuffer */
   // int dx = (cart.type ? 48 : 0);
   // int dy = (cart.type ? 48 : 24);
    int dx = 0;
    int dy = 0;

    /* Offset in display bitmap */
    int sx = (cart.type ? 48 : 0);
    int sy = (cart.type ? 24 : 0);

    for(y = 0; y < h; y += 1)
    {
        /* Point to current line of bitmap */
     //   char *p = &bitmap.data[((sy + y) * bitmap.width) + (sx)];

        for(x = 0; x < w; x += 1)
        {
            /* Strip priority and sprite marker bits */
       //     c = (p[x] & PIXEL_MASK);

            /* Look-up color components for given pixel */
            r = bitmap.pal.color[c][0];
            g = bitmap.pal.color[c][1];
            b = bitmap.pal.color[c][2];

            /* Write to framebuffer */
            putpixel(dx + x, dy + y, r, g, b);
     //       serial_printf("x: %s , y: %s , r: %s , g: %s , b: %s\n",dx+x,dy+y,r,g,b);
        }
    }
}


/* Show how many frames have been rendered */
void display_fcount() {
    if (show_dcfr == 1) {
       //bfont_draw(vram_s+10*s_width+10, s_width, frame_count);
       bfont_draw(vram_s+300*s_width+20, s_width, frame_count);
    }
}

/* Updates the Controller's input */
int update_input() {
    uint8 mmcont;
    cont_cond_t mcond;

  //  cont_cond_t cond;

    mmcont = maple_controller_addr();

    cont_get_cond(mmcont, &mcond);

    memset(&input, 0, sizeof(t_input));

    /* increase frame skip with the right trigger */
    if (mcond.rtrig) {
      if (frame_skip > 29) {
       frame_skip=30; /* dont let frame skip get too high */
      } else {
       frame_skip++; //add_msg("Frame skip disabled");
      }
      serial_printf("Increased frameskip to: %d\r\n", frame_skip);
      return(0);
    }

    /* decrease frame skip with the right trigger */
    if(mcond.ltrig) {
      if (frame_skip == 0) {
       frame_skip=0; /* unable to make frame skip -1 */
      } else {
       frame_skip=frame_skip-1;
      }
      serial_printf("Decreased frameskip to: %d\r\n", frame_skip);
      return(0);
    }

    /* enable/disable number of frames rendered */
    if(!(mcond.buttons  & CONT_X)) {
      if (show_dcfr == 0) {
         serial_printf("Displaying number of frames rendered on screen\r\n");
         show_dcfr = 1;
      } else if (show_dcfr == 1) {
         serial_printf("Disabled the display of the number of frames rendered on screen\r\n");
         show_dcfr = 0;
      }
      return(0);
    }

    /* exit if Y button pressed */
    if(!(mcond.buttons  & CONT_Y))               exit_flag = 1;

    /* general controllers */
    if(!(mcond.buttons  & CONT_START))           input.system |= (cart.type) ? INPUT_START : INPUT_PAUSE;
    if(!(mcond.buttons  & CONT_DPAD_UP))         input.pad[0] |= INPUT_UP;
    else
    if(!(mcond.buttons  & CONT_DPAD_DOWN))       input.pad[0] |= INPUT_DOWN;
    if(!(mcond.buttons  & CONT_DPAD_LEFT))       input.pad[0] |= INPUT_LEFT;
    else
    if(!(mcond.buttons  & CONT_DPAD_RIGHT))      input.pad[0] |= INPUT_RIGHT;
    if(!(mcond.buttons  & CONT_B))               input.pad[0] |= INPUT_BUTTON2;
    if(!(mcond.buttons  & CONT_A))               input.pad[0] |= INPUT_BUTTON1;

   /*  no controller 2 support yet... sorry. */
   /* if(pad2_mask & (1 << 12))   input.pad[1] |= INPUT_UP;
    else
    if(pad2_mask & (1 << 14))   input.pad[1] |= INPUT_DOWN;
    if(pad2_mask & (1 << 15))   input.pad[1] |= INPUT_LEFT;
    else
    if(pad2_mask & (1 << 13))   input.pad[1] |= INPUT_RIGHT;
    if(pad2_mask & (1 <<  7))   input.pad[1] |= INPUT_BUTTON2;
    if(pad2_mask & (1 <<  6))   input.pad[1] |= INPUT_BUTTON1; */
    return(0);
}


/* SRAM routines */
void system_load_sram()
{
    load_sram();
}
void system_save_sram()
{
    save_sram();
}
void load_sram()
{
    /* TODO: implement loading sram at */
}
void save_sram()
{
    /* TODO: implement saving sram */
}

/* Load a game image to run
 *  later change to int load_rom(char *filename); when GUI implemented
 */
void load_rom(void)
{
    int size;
    //char path[0x100];
    char *filename;
    FILE *fd = (FILE *) NULL;

    filename = "/GAME.SMS";

    serial_printf("Loading %s .......\r\n", filename);
    fd = fopen(filename, "rb");
    if (!fd) {
      screenprintf(20,"The ROM you selected was not found on this CD.",1);
      sleep(500);
      serial_printf("\r\n   [ FAILED ] .. please insert CD with GAME.SMS\r\n");
      for (;;) {
       fd = fopen(filename, "rb");
       if (fd) break;
          /* keep look for ROM till found, when GUI coded
          must remove tihs, and simply put return NULL or some thing */
      }
      clearscr(640,480);
    }
   /*
    cart.rom = &base_rom[0];
    size = iso_read(fd, cart.rom, ROM_SIZE); */

    /* seek to EOF and get size */
    serial_printf("Seeking EOF... ", filename);
    //fseek(((FILE*) fd), 0, SEEK_END);
    fseek(fd, 0, SEEK_END);

    serial_printf("DONE.\r\n", filename);

    serial_printf("Performing ftell... ", filename);
    size = ftell(fd);
    serial_printf("DONE.\r\n", filename);

    serial_printf("Seeking SEEK_SET... ", filename);
    fseek(fd, 0, SEEK_SET);
    serial_printf("DONE.\r\n", filename);

    /* Don't load games smaller than 32k */
    if(size < 32000) {
      fclose(fd);
      screenprintf(20,"The ROM you selected is INVALID, it must be",1);
      sleep(500);
      screenprintf(45,"larger than 32k... can not continue.",1);
      sleep(60*1000); /* wait for 1min */
      serial_printf(" [ FAILED ] .... %s must be LARGER THAN 32k\r\nThe ROM you selected is only '%d' bytes", filename, size);
      for(;;);
    }

    /* Skip ROM 512byte header if present */
    if((size / 512) & 1) {
       serial_printf(" [ 512byte header found ] ... ");
       size -= 512;
       fseek(fd, 512, SEEK_SET);
    }

    cart.pages = (size / 0x4000);
    cart.rom = malloc(size);
//    fread(cart.rom, size, 1, ((FILE*) fd));
    fread((char *) cart.rom, size, 1, fd);

    fclose(fd);

    serial_printf("  [ DONE ] (ROM LOADED)\r\n");
#ifdef DCDEBUG
       serial_printf("Loaded file %s, %d bytes.\r\n", filename, size);
#endif

    cart.type = 0;

    /* if(strcmp(strrchr(path, '.'), ".gg") == 0)
    {
        cart.type = 1;
    } */
     /*********************************************************
      * right now we only use .SMS roms, when GUI coded, must *
      * re-implement this feature..                           *
      ********************************************************/
}

/* write some text to the screen (use just for errors, notices, etc) */
int screenprintf(int xpos, char *text, int type) {
    if (type == 0) {
       bfont_draw_str(vram_s+xpos*s_width+20, s_width, text);
    } else {
       bfont_draw_twriter(vram_s+xpos*s_width+20, s_width, text);
    }
    return(0);
}

/* draw text on screen, typewriter style */
void bfont_draw_twriter(uint16 *buffer, int bufwidth, char *str) {
    while (*str) {
        bfont_draw(buffer += 12, bufwidth, *str++);
        sleep(100); /* sleep for 1/2 second */
    }
}

/* put a pixel on to the screen */
void putpixel(int x, int y, int r, int g, int b)
{
  //  vram_s[x+(s_width*y)] = RGB565(r,g,b);
    vram_s[y*640+x] = RGB565(r,g,b);
}

/* clear the screen */
void clearscr(int xres, int yres) {
    int x, y;
    for(x = 0; x < xres; x++)
            for(y = 0; y < yres; y++)
                    vram_s[xres*y + x] = 0;
}

/* Clear a rectangluar region of the framebuffer */
void fb_rect(int x, int y, int w, int h, int r, int g, int b)
{
   // vram_s[x+(s_width*h)] = RGB565(r,g,b);
    for(; x < w; x++)
            for(; y < h; y++)
                    vram_s[w*y + x] = RGB565(r,g,b);
}

